# -*- coding: utf-8 -*-
try:
	from urllib2 import urlopen
except ImportError:
	from urllib.request import urlopen
try:
	from urllib import urlencode
except ImportError:
	from urllib.parse import urlencode
try:
	from urlparse import urlparse, parse_qs
except ImportError:
	from urllib.parse import urlparse, parse_qs
import json
import re

def httpget(url):
	file = urlopen(url)
	content = file.read()
	content = content.decode('utf-8')
	file.close()
	return content

def live(url):
	import xbmc
	offset = url.find('pa://cctv_p2p_hd')
	if offset < 0:
		return {'success': False, 'code': 'cntv 200'}
	offset += 16
	channel = url[offset:]
	xbmc.log(channel, xbmc.LOGNOTICE)
	if channel[:4] == 'cctv':
		sub = 'cctv'
	else:
		sub = 'wstv'
	xbmc.log(sub, xbmc.LOGNOTICE)
	try:
		content = httpget(url)
	except:
		return {'success': False, 'code': 'cntv 201'}
	try:
		data = json.loads(content)
	except:
		return {'success': False, 'code': 'cntv 202'}
	if 'hls_url' not in data:
		return {'success': False, 'code': 'cntv 203'}
	result = {'success': True, 'item': []}
	for item in data['hls_url']:
		if data['hls_url'][item][:4] == sub:
			if sub == 'wstv':
				url = 'http://' + sub + '.cntv.cdnpe.com/cntvlive/' + channel + 'md.m3u8' + data['hls_url'][item][4:]
				xbmc.log(url, xbmc.LOGNOTICE)
				result['item'].append({'title': 'md', 'url': url})
			else:
				url = 'http://' + sub + '.cntv.cdnpe.com/cntvlive/' + channel + '.m3u8' + data['hls_url'][item][4:]
				try:
					content = httpget(url)
				except:
					return {'success': False, 'code': 'cntv 204'}
				for line in content.split('\n'):
					line = line.strip()
					if not line:
						continue
					if line[0] == '#':
						continue
					result['item'].append({'title': line, 'url': 'http://' + sub + '.cntv.cdnpe.com' + line})
	return result

def play(url):
	try:
		content = httpget(url)
	except:
		return {'success': False, 'code': 'cntv 100'}
	videoCenterId = re.search('"videoCenterId","(.*?)"', content)
	if videoCenterId == None:
		return {'success': False, 'code': 'cntv 101'}
	videoCenterId = videoCenterId.group(1)
	url = 'http://vdn.apps.cntv.cn/api/getHttpVideoInfo.do?pid=' + videoCenterId
	try:
		content = httpget(url)
	except:
		return {'success': False, 'code': 'cntv 102'}
	try:
		data = json.loads(content)
	except:
		return {'success': False, 'code': 'cntv 103'}
	try:
		title = data['title']
		chapters = data['video']['chapters']
	except:
		return {'success': False, 'code': 'cntv 104'}
	result = {'success': True, 'title': title, 'url': []}
	for chapter in chapters:
		try:
			result['url'].append(chapter['url'])
		except:
			return {'success': False, 'code': 'cntv 105'}
	return result

def videolist(url):
	o = urlparse(url)
	q = parse_qs(o.query)
	url = 'http://api.cntv.cn/lanmu/videolistByColumnId?id=%s&serviceId=tvcctv&type=0&n=36&p=%s&t=jsonp&cb=Callback' % (q['id'][0], q['p'][0])
	try:
		content = httpget(url)
	except:
		return {'success': False, 'code': 'cntv 400'}
	content = re.search('.*?\((.*)\).*?', content, re.DOTALL)
	if content == None:
		return {'success': False, 'code': 'cntv 401'}
	content = content.group(1)
	try:
		data = json.loads(content)
	except:
		return {'success': False, 'code': 'cntv 402'}
	result = {'success': True, 'item': []}
	for elem in data['response']['docs']:
		result['item'].append({'title': elem['videoTitle'], 'url': elem['videoUrl'], 'folder': False})
	url = 'http://api.cntv.cn/lanmu/videolistByColumnId?id=%s&serviceId=tvcctv&type=0&n=36&p=%d&t=jsonp&cb=Callback' % (q['id'][0], int(q['p'][0]) + 1)
	result['item'].append({'title': 'next', 'url': url, 'folder': True})
	return result

def videoset(url):
	try:
		content = httpget(url)
	except:
		return {'success': False, 'code': 'cntv 300'}
	id = re.search('http://api\.cntv\.cn/lanmu/videolistByColumnId\?id=(.*?)&', content, re.DOTALL)
	if id == None:
		return {'success': False, 'code': 'cntv 301'}
	id = id.group(1)
	var = re.search('\s*\'\s*\+\s*(.*?)\s*\+\s*\'\s*', id)
	if var:
		var = var.group(1)
		id = re.search(var + '\s*=\s*\'(.*?)\'', content, re.DOTALL)
		if id == None:
			return {'success': False, 'code': 'cntv 302'}
		id = id.group(1)
	url = 'http://api.cntv.cn/lanmu/videolistByColumnId?id=' + id + '&serviceId=tvcctv&type=0&n=36&p=1&t=jsonp&cb=Callback'
	return videolist(url)
